package hd.server.timesheet;

import hd.client.profile.Employee;
import hd.server.profile.UserServiceImpl;
import junit.framework.TestCase;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;

import com.google.appengine.tools.development.testing.LocalDatastoreServiceTestConfig;
import com.google.appengine.tools.development.testing.LocalServiceTestHelper;

/** Tests all the TimesheetServiceImpl
 * 
 * @author Eric Greer (egreer@alum.wpi.edu)
 * @author Jason Codding (jcodding@alum.wpi.edu)
 * WPI Helpdesk MQP 2009-2010
 *
 */
public class TimesheetServiceImplTest extends TestCase{

    private final LocalServiceTestHelper helper =
        new LocalServiceTestHelper(new LocalDatastoreServiceTestConfig());

	TimesheetServiceImpl service = new TimesheetServiceImpl();
	UserServiceImpl UserService = new UserServiceImpl();
	Employee eric = new Employee();
	Employee jason = new Employee();
	
	@Before
	public void setUp() throws Exception {
		helper.setUp();
		
		eric.setFirstName("Eric");
		eric.setLastName("Greer");
		UserService.createProfile(eric);
		
		jason.setFirstName("Jason");
		jason.setLastName("Codding");
		UserService.createProfile(jason);
	}

	@After
	public void tearDown() throws Exception {
		helper.tearDown();
		
		eric = new Employee();
		jason = new Employee();
	}

	@Test
	public void testChangeTimesheetStatus() {
		fail("Not yet implemented");
	}

	@Test
	public void testRetrieveCurrentTimesheetString() {
		fail("Not yet implemented");
	}

	@Test
	public void testRetrieveCurrentTimesheetEmployee() {
		fail("Not yet implemented");
	}

	@Test
	public void testRetrieveTimesheet() {
		fail("Not yet implemented");
	}

	@Test
	public void testRetrieveScheduleDetails() {
		fail("Not yet implemented");
	}

	@Test
	public void testUpdateScheduleDetails() {
		fail("Not yet implemented");
	}

	@Test
	public void testUploadW2Work() {
		fail("Not yet implemented");
	}

	@Test
	public void testRetrieveAllTimesheets() {
		fail("Not yet implemented");
	}

	@Test
	public void testRetrieveAllTimesheetsEmployee() {
		fail("Not yet implemented");
	}

	@Test
	public void testRetrieveAllTimesheetsStatus() {
		fail("Not yet implemented");
	}

	@Test
	public void testGetScheduleDetail() {
		fail("Not yet implemented");
	}

	@Test
	public void testChangeTimesheetPrintStatus() {
		fail("Not yet implemented");
	}

	@Test
	public void testUploadXML() {
		String returned = service.uploadXML(xml);
		System.out.println(returned);
		fail("Not yet implemented");
	}

	final String xml = "<?xml version=\"1.0\" encoding=\"windows-1252\" standalone=\"yes\"?><!-- Generated by WhenToWork--><!DOCTYPE tutorial [    <!ENTITY auml \"&amp;auml;\">    <!ENTITY ouml \"&amp;ouml;\">    <!ENTITY uuml \"&amp;uuml;\">    <!ENTITY Auml \"&amp;Auml;\">    <!ENTITY Ouml \"&amp;Ouml;\">    <!ENTITY Uuml \"&amp;Uuml;\">    <!ENTITY szlig \"&amp;szlig;\">    <!ENTITY ret \"&amp;lt;br/&amp;gt;\">    <!ENTITY car \"\">]><RECORDS><METADATA><FIELDS><FIELD attrname=\"SCEMTRANSACTIONID\" fieldtype=\"i4\" required=\"true\"/><FIELD attrname=\"SCEMSCHEDULEID\" fieldtype=\"i4\" required=\"true\"/><FIELD attrname=\"EMPEMPLOYEENUMBER\" fieldtype=\"string\" WIDTH=\"42\"/><FIELD attrname=\"SCEMREQUIREDSKILLID\" fieldtype=\"i4\" required=\"true\"/><FIELD attrname=\"SKDESCRIPTION\" fieldtype=\"string\" WIDTH=\"402\"/><FIELD attrname=\"CASHORTDESC\" fieldtype=\"string\" WIDTH=\"16\"/><FIELD attrname=\"SCEMDESCRIPTION\" fieldtype=\"string\" WIDTH=\"1002\"/><FIELD attrname=\"CSCEMWORKDAY\" fieldtype=\"datetime\"/><FIELD attrname=\"SCEMSTARTTIME\" fieldtype=\"time\"/><FIELD attrname=\"SCEMENDTIME\" fieldtype=\"time\"/><FIELD attrname=\"SCEMDURATION\" fieldtype=\"r8\"/><FIELD attrname=\"SCEMDAYTOWORK\" fieldtype=\"i4\"/><FIELD attrname=\"EMPNAME\" fieldtype=\"string\" WIDTH=\"164\" readonly=\"true\"/><FIELD attrname=\"EMPFIRSTNAME\" fieldtype=\"string\" WIDTH=\"82\"/><FIELD attrname=\"EMPLASTNAME\" fieldtype=\"string\" WIDTH=\"82\"/></FIELDS><PARAMS DEFAULT_ORDER=\"1\" PRIMARY_KEY=\"1\" LCID=\"1033\"/></METADATA>  <RECORD>    <ROW      Shift_ID=\"315971983\"      Schedule_ID=\"315971962\"      Position_ID=\"300553043\"      Position_Name=\"Helpdesk Student Specialist\"      Date=\"20100315\"      Start_Time=\"08:00:00\"      End_Time=\"10:00:00\"      Duration=\"   2.0\"      Day_Of_Week=\"0\"      Employee_Name=\"Carmel Kozlov\"      Employee_First_Name=\"Carmel\"      Employee_Last_Name=\"Kozlov\"    />  </RECORD>  <RECORD>    <ROW      Shift_ID=\"315971974\"      Schedule_ID=\"315971962\"      Position_ID=\"300553043\"      Position_Name=\"Helpdesk Student Specialist\"      Date=\"20100315\"      Start_Time=\"08:00:00\"      End_Time=\"10:00:00\"      Duration=\"   2.0\"      Day_Of_Week=\"0\"      Employee_Name=\"Eric Magnuson\"      Employee_First_Name=\"Eric\"      Employee_Last_Name=\"Magnuson\"    />  </RECORD>  <RECORD>    <ROW      Shift_ID=\"315971992\"      Schedule_ID=\"315971962\"      Position_ID=\"300553043\"      Position_Name=\"Helpdesk Student Specialist\"      Date=\"20100315\"      Start_Time=\"10:00:00\"      End_Time=\"12:00:00\"      Duration=\"   2.0\"      Day_Of_Week=\"0\"      Employee_Name=\"Caleb Ruvich\"      Employee_First_Name=\"Caleb\"      Employee_Last_Name=\"Ruvich\"    />  </RECORD>  <RECORD>    <ROW      Shift_ID=\"315972065\"      Schedule_ID=\"315971962\"      Position_ID=\"300553043\"      Position_Name=\"Helpdesk Student Specialist\"      Date=\"20100315\"      Start_Time=\"10:00:00\"      End_Time=\"12:00:00\"      Duration=\"   2.0\"      Day_Of_Week=\"0\"      Employee_Name=\"Madison Dickson\"      Employee_First_Name=\"Madison\"      Employee_Last_Name=\"Dickson\"    />  </RECORD>  <RECORD>    <ROW      Shift_ID=\"315971981\"      Schedule_ID=\"315971962\"      Position_ID=\"300553043\"      Position_Name=\"Helpdesk Student Specialist\"      Date=\"20100315\"      Start_Time=\"10:00:00\"      End_Time=\"12:00:00\"      Duration=\"   2.0\"      Day_Of_Week=\"0\"      Employee_Name=\"Matthew Ferreira\"      Employee_First_Name=\"Matthew\"      Employee_Last_Name=\"Ferreira\"    />  </RECORD>  <RECORD>    <ROW      Shift_ID=\"315972014\"      Schedule_ID=\"315971962\"      Position_ID=\"300553043\"      Position_Name=\"Helpdesk Student Specialist\"      Date=\"20100315\"      Start_Time=\"12:00:00\"      End_Time=\"14:00:00\"      Duration=\"   2.0\"      Day_Of_Week=\"0\"      Employee_Name=\"Brian Ketterer\"      Employee_First_Name=\"Brian\"      Employee_Last_Name=\"Ketterer\"    />  </RECORD>  <RECORD>    <ROW      Shift_ID=\"315972009\"      Schedule_ID=\"315971962\"      Position_ID=\"300553043\"      Position_Name=\"Helpdesk Student Specialist\"      Date=\"20100315\"      Start_Time=\"12:00:00\"      End_Time=\"14:00:00\"      Duration=\"   2.0\"      Day_Of_Week=\"0\"      Employee_Name=\"Danielle Beaulieu\"      Employee_First_Name=\"Danielle\"      Employee_Last_Name=\"Beaulieu\"    />  </RECORD>  <RECORD>    <ROW      Shift_ID=\"315972004\"      Schedule_ID=\"315971962\"      Position_ID=\"300553043\"      Position_Name=\"Helpdesk Student Specialist\"      Date=\"20100315\"      Start_Time=\"12:00:00\"      End_Time=\"14:00:00\"      Duration=\"   2.0\"      Day_Of_Week=\"0\"      Employee_Name=\"Jason Codding\"      Employee_First_Name=\"Jason\"      Employee_Last_Name=\"Codding\"    />  </RECORD>  <RECORD>    <ROW      Shift_ID=\"315971980\"      Schedule_ID=\"315971962\"      Position_ID=\"300553043\"      Position_Name=\"Helpdesk Student Specialist\"      Date=\"20100317\"      Start_Time=\"12:00:00\"      End_Time=\"14:00:00\"      Duration=\"   2.0\"      Day_Of_Week=\"2\"      Employee_Name=\"Eric Greer\"      Employee_First_Name=\"Eric\"      Employee_Last_Name=\"Greer\"    />  </RECORD>  <RECORD>    <ROW      Shift_ID=\"316253598\"      Schedule_ID=\"315971962\"      Position_ID=\"307592989\"      Position_Name=\"Squid\"      Date=\"20100314\"      Start_Time=\"13:00:00\"      End_Time=\"16:00:00\"      Duration=\"   3.0\"      Day_Of_Week=\"6\"      Employee_Name=\"Jason Codding\"      Employee_First_Name=\"Jason\"      Employee_Last_Name=\"Codding\"    />  </RECORD>  <RECORD>    <ROW      Shift_ID=\"315972019\"      Schedule_ID=\"315971962\"      Position_ID=\"300553043\"      Position_Name=\"Helpdesk Student Specialist\"      Date=\"20100319\"      Start_Time=\"14:00:00\"      End_Time=\"16:00:00\"      Duration=\"   2.0\"      Day_Of_Week=\"4\"      Employee_Name=\"Eric Greer\"      Employee_First_Name=\"Eric\"      Employee_Last_Name=\"Codding\"    />  </RECORD>  <RECORD>    <ROW      Shift_ID=\"315972026\"      Schedule_ID=\"315971962\"      Position_ID=\"300553043\"      Position_Name=\"Helpdesk Student Specialist\"      Date=\"20100315\"      Start_Time=\"14:00:00\"      End_Time=\"16:00:00\"      Duration=\"   2.0\"      Day_Of_Week=\"0\"      Employee_Name=\"Eric Greer\"      Employee_First_Name=\"Eric\"      Employee_Last_Name=\"Greer\"    />  </RECORD>  <RECORD>    <ROW      Shift_ID=\"315972059\"      Schedule_ID=\"315971962\"      Position_ID=\"300553043\"      Position_Name=\"Helpdesk Student Specialist\"      Date=\"20100318\"      Start_Time=\"14:00:00\"      End_Time=\"16:00:00\"      Duration=\"   2.0\"      Day_Of_Week=\"3\"      Employee_Name=\"Jason Codding\"      Employee_First_Name=\"Jason\"      Employee_Last_Name=\"Codding\"    />  </RECORD>  <RECORD>    <ROW      Shift_ID=\"315972024\"      Schedule_ID=\"315971962\"      Position_ID=\"300553043\"      Position_Name=\"Helpdesk Student Specialist\"      Date=\"20100315\"      Start_Time=\"14:00:00\"      End_Time=\"16:00:00\"      Duration=\"   2.0\"      Day_Of_Week=\"0\"      Employee_Name=\"Eric Greer\"      Employee_First_Name=\"Eric\"      Employee_Last_Name=\"Greer\"    />  </RECORD>  </RECORDS>";
}
